SystemOrganization addCategory: #'Collections-Tests-OrderPreservingDictionary'!

TestCase subclass: #StandardOrderedDictionaryTest
	instanceVariableNames: 'nonIdentityOrderedAssociations identityOrderedAssociations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-OrderPreservingDictionary'!

StandardOrderedDictionaryTest subclass: #LazyStandardOrderedDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-OrderPreservingDictionary'!

!LazyStandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 4/9/2017 19:58'!
dictionaryClass
	^ LazyStandardOrderedDictionary! !

!LazyStandardOrderedDictionaryTest methodsFor: 'testing' stamp: 'monty 4/11/2017 01:32'!
isTestingLazyDictionary
	^ true! !

StandardOrderedDictionaryTest subclass: #OrderPreservingDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-OrderPreservingDictionary'!

OrderPreservingDictionaryTest subclass: #LazyOrderPreservingDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-OrderPreservingDictionary'!

!LazyOrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'monty 4/10/2017 22:18'!
dictionaryClass
	^ LazyOrderPreservingDictionary! !

!LazyOrderPreservingDictionaryTest methodsFor: 'testing' stamp: 'monty 4/11/2017 01:32'!
isTestingLazyDictionary
	^ true! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'monty 11/20/2014 18:48'!
defaultValue
	^ 'defaultValue'! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'monty 11/20/2014 18:50'!
dictionaryClass
	^ OrderPreservingDictionary! !

!OrderPreservingDictionaryTest methodsFor: 'accessing' stamp: 'monty 11/20/2014 18:58'!
newDefaultValue
	^ 'newDefaultValue'! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 9/29/2016 20:27'!
testAssociationAt
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self assert: (dictionary associationAt: each key) isNil.

		dictionary add: each.
		self assert: (dictionary associationAt: each key) = each].! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:28'!
testAssociationsSelect
	super testAssociationsSelect.

	self assert:
		(self dictionaryWithOrderedAssociations
			defaultValue: self defaultValue;
			associationsSelect: [:each | true]) defaultValue = self defaultValue.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 9/29/2016 20:21'!
testAt
	| dictionary |

	dictionary := self emptyDictionary.
	dictionary defaultValue: self defaultValue.
	self orderedAssociations do: [:each |
		self assert: (dictionary at: each key) = self defaultValue.

		dictionary add: each.
		self assert: (dictionary at: each key) = each value].! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 9/29/2016 20:21'!
testCapacity
	| defaultCapacity dictionary |

	super testCapacity.

	defaultCapacity := self defaultCapacity.
	dictionary := self dictionaryClass defaultValue: nil.
	self assert: dictionary capacity >= defaultCapacity.

	dictionary :=
		self dictionaryClass
			new: defaultCapacity * 2
			withDefaultValue: nil.
	self assert: dictionary capacity >= (defaultCapacity * 2).! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:28'!
testCollect
	super testCollect.

	self assert:
		(self dictionaryWithOrderedAssociations
			defaultValue: self defaultValue;
			collect: [:each | each]) defaultValue = self defaultValue.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:28'!
testCopy
	| dictionary copy |

	super testCopy.

	dictionary := self dictionaryWithOrderedAssociations.
	dictionary defaultValue: self defaultValue.
	copy := dictionary copy.
	self assert: copy defaultValue = dictionary defaultValue.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:28'!
testCopyEmpty
	| dictionary copy |

	super testCopyEmpty.
	
	dictionary := self dictionaryWithOrderedAssociations.
	dictionary defaultValue: self defaultValue.
	copy := dictionary copyEmpty.
	self assert: copy defaultValue = dictionary defaultValue.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 22:40'!
testDefaultValue
	| dictionary |
	
	dictionary := self dictionaryClass defaultValue: self defaultValue.
	self
		assert: dictionary defaultValue = self defaultValue;
		assert: (dictionary defaultValue: self newDefaultValue) == dictionary;
		assert: dictionary defaultValue = self newDefaultValue.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 16:11'!
testKeyAtIdentityValue
	| dictionary |

	dictionary := self emptyDictionary.
	dictionary defaultValue: self defaultValue.
	self orderedAssociations do: [:each |
		self assert:
			(dictionary keyAtIdentityValue: each value) = self defaultValue.

		dictionary add: each.
		self assert:
			(dictionary keyAtIdentityValue: each value) = each key.
		self assert:
			(dictionary keyAtIdentityValue: each value copy) = self defaultValue].! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 16:10'!
testKeyAtIndex
	| dictionary |

	dictionary := self emptyDictionary.
	dictionary defaultValue: self defaultValue.
	self assert: (dictionary keyAtIndex: 0) = self defaultValue.
	self orderedAssociations withIndexDo: [:each :i |
		self assert: (dictionary keyAtIndex: i) = self defaultValue.

		dictionary add: each.
		self assert: (dictionary keyAtIndex: i) = each key].! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 23:43'!
testKeyAtValue
	| dictionary |

	dictionary := self emptyDictionary.
	dictionary defaultValue: self defaultValue.
	self orderedAssociations do: [:each |
		self assert: (dictionary keyAtValue: each value) = self defaultValue.

		dictionary add: each.
		self assert: (dictionary keyAtValue: each value) = each key].! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 22:37'!
testNewFrom
	| dictionary copy |

	super testNewFrom.

	dictionary := self dictionaryClass newFrom: self orderedAssociations.
	dictionary defaultValue: self defaultValue.
	copy := self dictionaryClass newFrom: dictionary.
	self assert: copy defaultValue = dictionary defaultValue.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 22:42'!
testNewWithDefaultValue
	| dictionary |

	dictionary :=
		self dictionaryClass
			new: 10
			withDefaultValue: self defaultValue.
	self assert: dictionary defaultValue = self defaultValue.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 4/10/2017 22:43'!
testRemoveAll
	| dictionary |

	super testRemoveAll.

	dictionary := self dictionaryWithOrderedAssociations.
	dictionary
		defaultValue: self defaultValue;
		removeAll.
	self assert: dictionary defaultValue = self defaultValue.! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:28'!
testRemoveKey
	| dictionary |

	dictionary := self dictionaryWithOrderedAssociations.
	dictionary defaultValue: self defaultValue.
	self orderedAssociations withIndexDo: [:each :i |
		self assert: (dictionary removeKey: each key) = each value.
		self
			assertKey: each key
			wasRemovedfrom: dictionary.
		self
			assertIsDictionary: dictionary
			withOrderedAssociations: (self orderedAssociationsAllButFirst: i).

		self assert: (dictionary removeKey: each key) = self defaultValue]! !

!OrderPreservingDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:28'!
testSelect
	super testSelect.

	self assert:
		(self dictionaryWithOrderedAssociations
			defaultValue: self defaultValue;
			select: [:each | true]) defaultValue = self defaultValue.! !

OrderPreservingDictionaryTest subclass: #OrderPreservingIdentityDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-OrderPreservingDictionary'!

OrderPreservingIdentityDictionaryTest subclass: #LazyOrderPreservingIdentityDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-OrderPreservingDictionary'!

!LazyOrderPreservingIdentityDictionaryTest methodsFor: 'accessing' stamp: 'monty 4/10/2017 22:18'!
dictionaryClass
	^ LazyOrderPreservingIdentityDictionary! !

!LazyOrderPreservingIdentityDictionaryTest methodsFor: 'testing' stamp: 'monty 4/11/2017 01:32'!
isTestingLazyDictionary
	^ true! !

!OrderPreservingIdentityDictionaryTest methodsFor: 'accessing' stamp: 'monty 10/18/2014 08:55'!
dictionaryClass
	^ OrderPreservingIdentityDictionary! !

!OrderPreservingIdentityDictionaryTest methodsFor: 'testing' stamp: 'monty 12/15/2014 16:44'!
isTestingIdentityDictionary
	^ true! !

StandardOrderedDictionaryTest subclass: #OrderPreservingStringDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-OrderPreservingDictionary'!

OrderPreservingStringDictionaryTest subclass: #LazyOrderPreservingStringDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-OrderPreservingDictionary'!

!LazyOrderPreservingStringDictionaryTest methodsFor: 'accessing' stamp: 'monty 4/10/2017 22:12'!
dictionaryClass
	^ LazyOrderPreservingStringDictionary! !

!LazyOrderPreservingStringDictionaryTest methodsFor: 'testing' stamp: 'monty 4/11/2017 01:32'!
isTestingLazyDictionary
	^ true! !

OrderPreservingStringDictionaryTest subclass: #OrderPreservingIdentityStringDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-OrderPreservingDictionary'!

OrderPreservingIdentityStringDictionaryTest subclass: #LazyOrderPreservingIdentityStringDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-OrderPreservingDictionary'!

!LazyOrderPreservingIdentityStringDictionaryTest methodsFor: 'accessing' stamp: 'monty 4/10/2017 22:13'!
dictionaryClass
	^ LazyOrderPreservingIdentityStringDictionary! !

!LazyOrderPreservingIdentityStringDictionaryTest methodsFor: 'testing' stamp: 'monty 4/11/2017 01:32'!
isTestingLazyDictionary
	^ true! !

!OrderPreservingIdentityStringDictionaryTest methodsFor: 'accessing' stamp: 'monty 11/20/2014 20:01'!
dictionaryClass
	^ OrderPreservingIdentityStringDictionary! !

!OrderPreservingIdentityStringDictionaryTest methodsFor: 'testing' stamp: 'monty 12/15/2014 16:44'!
isTestingIdentityDictionary
	^ true! !

!OrderPreservingStringDictionaryTest methodsFor: 'accessing' stamp: 'monty 11/20/2014 19:55'!
dictionaryClass
	^ OrderPreservingStringDictionary! !

!OrderPreservingStringDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 16:09'!
testAssociationAt
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self assert: (dictionary associationAt: each key) isNil.
	
		dictionary add: each.
		self assert: (dictionary associationAt: each key) = each].! !

!OrderPreservingStringDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 16:09'!
testAt
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self assert: (dictionary at: each key) = ''.

		dictionary add: each.
		self assert: (dictionary at: each key) = each value].! !

!OrderPreservingStringDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 03:22'!
testKeyAtIdentityValue
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self assert: (dictionary keyAtIdentityValue: each value) = ''.

		dictionary add: each.
		self
			assert: (dictionary keyAtIdentityValue: each value) = each key;
			assert: (dictionary keyAtIdentityValue: each value copy) = ''].! !

!OrderPreservingStringDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 16:10'!
testKeyAtIndex
	| dictionary |

	dictionary := self emptyDictionary.
	self assert: (dictionary keyAtIndex: 0) = ''.
	self orderedAssociations withIndexDo: [:each :i |
		self assert: (dictionary keyAtIndex: i) = ''.

		dictionary add: each.
		self assert: (dictionary keyAtIndex: i) = each key].! !

!OrderPreservingStringDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 02:44'!
testKeyAtValue
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self assert: (dictionary keyAtValue: each value) = ''.

		dictionary add: each.
		self assert: (dictionary keyAtValue: each value) = each key].! !

!OrderPreservingStringDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:28'!
testRemoveKey
	| dictionary |

	dictionary := self dictionaryWithOrderedAssociations.
	self orderedAssociations withIndexDo: [:each :i |
		self assert: (dictionary removeKey: each key) = each value.
		self
			assertKey: each key
			wasRemovedfrom: dictionary.
		self
			assertIsDictionary: dictionary
			withOrderedAssociations: (self orderedAssociationsAllButFirst: i).

		self assert: (dictionary removeKey: each key) = '']! !

!StandardOrderedDictionaryTest class methodsFor: 'testing' stamp: 'monty 10/1/2016 14:01'!
shouldInheritSelectors
	^ true! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 12/15/2014 16:44'!
absentKey
	self isTestingIdentityDictionary
		ifTrue: [^ self identityAbsentKey]
		ifFalse: [^ self nonIdentityAbsentKey]! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/19/2011 20:09'!
absentValue
	^ 'absentValue'! !

!StandardOrderedDictionaryTest methodsFor: 'assertions' stamp: 'monty 9/30/2016 22:17'!
assertDictionary: aFirstDictionary doesNotEqual: aSecondDictionary
	"test symmetric inequality"
	self
		deny: aFirstDictionary = aSecondDictionary;
		deny: aSecondDictionary = aFirstDictionary! !

!StandardOrderedDictionaryTest methodsFor: 'assertions' stamp: 'monty 9/30/2016 22:17'!
assertDictionary: aFirstDictionary equals: aSecondDictionary
	"test reflixive and symmetric equality"
	self
		assert: aFirstDictionary = aFirstDictionary;
		assert: aFirstDictionary = aSecondDictionary;
		assert: aSecondDictionary = aSecondDictionary;
		assert: aSecondDictionary = aFirstDictionary! !

!StandardOrderedDictionaryTest methodsFor: 'assertions' stamp: 'monty 9/30/2016 13:15'!
assertIsArray: anArray withElements: aCollection
	self
		assert: anArray isArray;
		assert: anArray = aCollection asArray! !

!StandardOrderedDictionaryTest methodsFor: 'assertions' stamp: 'monty 9/30/2016 22:16'!
assertIsDictionary: aFirstDictionary copiedFrom: aSecondDictionary withOrderedAssociations: anAssociationCollection
	self
		deny: aFirstDictionary == aSecondDictionary;
		deny: aFirstDictionary dictionary == aSecondDictionary dictionary;
		deny: aFirstDictionary orderedKeys == aSecondDictionary orderedKeys.

	"esnure the associations were copied (the keys and values can be shared)"
	aFirstDictionary associations do: [:each |
		self deny: (aSecondDictionary associations identityIncludes: each)].

	self
		assertIsDictionary: aFirstDictionary
		withOrderedAssociations: anAssociationCollection.! !

!StandardOrderedDictionaryTest methodsFor: 'assertions' stamp: 'monty 10/3/2016 20:48'!
assertIsDictionary: anObject withOrderedAssociations: anAssociationCollection
	"tests that anObject is an instance of the correct dictionary class
	with the specified ordered associations"
	self
		assert: anObject class == self dictionaryClass;
		assert: anObject orderedKeys size >= anAssociationCollection size;
		assert: anObject associations size = anAssociationCollection size.

	anAssociationCollection withIndexDo: [:each :i |
		self isTestingIdentityDictionary
			ifTrue: [
				self
					assert: (anObject orderedKeys at: i) == each key;
					assert: (anObject associations at: i) key == each key]
			ifFalse: [
				self
					assert: (anObject orderedKeys at: i) = each key;
					assert: (anObject associations at: i) key = each key].
		self assert: (anObject associations at: i) value = each value].! !

!StandardOrderedDictionaryTest methodsFor: 'assertions' stamp: 'monty 9/8/2016 02:02'!
assertIsDictionary: anObject withUnorderedAssociations: anAssociationCollection
	"tests that anObject is an instance of the correct dictionary class
	with the specified associations, but ignoring the order"
	self
		assert: anObject class == self dictionaryClass;
		assert: anObject size = anAssociationCollection size.
	anAssociationCollection do: [:each |
		self assert: (anObject includesAssociation: each)].! !

!StandardOrderedDictionaryTest methodsFor: 'assertions' stamp: 'monty 9/30/2016 03:20'!
assertKey: aKey wasRemovedfrom: aDictionary
	self deny: (aDictionary includesKey: aKey).
	aDictionary keys asArray, aDictionary orderedKeys asArray do: [:each |
		self deny:
			(self isTestingIdentityDictionary
				ifTrue: [each == aKey]
				ifFalse: [each = aKey])].! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 10/1/2016 01:29'!
changedOrderedAssociations
	^ self orderedAssociations collect: [:each | each key -> self newValue]! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 10/1/2016 01:29'!
changedOrderedAssociationsFirst: anInteger
	"GS does not have #first:"
	^ self changedOrderedAssociations
		copyFrom: 1
		to: anInteger! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 9/8/2016 02:04'!
collectClass
	^ Array! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 12/15/2014 16:36'!
defaultCapacity
	^ self emptyInternalDictionary capacity! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 11/20/2014 18:49'!
dictionaryClass
	^ StandardOrderedDictionary! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 10/1/2016 01:28'!
dictionaryWithOrderedAssociations
	^ self dictionaryClass newFrom: self orderedAssociations! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 12/5/2010 01:04'!
emptyDictionary
	^ self dictionaryClass new! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 12/15/2014 16:34'!
emptyInternalDictionary
	^ self internalDictionaryClass new! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 9/30/2016 16:52'!
identityAbsentKey
	^ self orderedKeys first copy! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 10/1/2016 15:04'!
identityOrderedAssociations
	"Returns ordered associations to use for identity dictionaries.
	The keys are all #= equal but #== different, so only an
	identity dictionary will be able to distinguish them."
	identityOrderedAssociations
		ifNil: [| key |
			key := 'testKey'.
			identityOrderedAssociations :=
				Array
					with: (key := key copy) -> 'testValue'
					with: (key := key copy) -> 'testValue3'
					with: (key := key copy) -> 'testValue2'
					with: (key := key copy) -> 'testValue4'].
	"return copies of the associations so they can be safely modified
	in one test without affecting another, but do not copy the keys
	and values"
	^ identityOrderedAssociations collect: [:each | each copy].! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 12/15/2014 16:44'!
internalDictionaryClass
	self isTestingIdentityDictionary
		ifTrue: [^ IdentityDictionary]
		ifFalse: [^ Dictionary]! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 9/29/2016 14:17'!
internalDictionaryWithAssociations
	^ self internalDictionaryClass newFrom: self orderedAssociations! !

!StandardOrderedDictionaryTest methodsFor: 'testing' stamp: 'monty 12/15/2014 16:44'!
isTestingIdentityDictionary
	^ false! !

!StandardOrderedDictionaryTest methodsFor: 'testing' stamp: 'monty 4/11/2017 01:32'!
isTestingLazyDictionary
	^ false! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'JAAyer 1/19/2011 20:09'!
newValue
	^ 'newValue'! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 12/15/2014 16:08'!
nonIdentityAbsentKey
	^ 'absentKey'! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 10/1/2016 15:11'!
nonIdentityOrderedAssociations
	"Returns ordered associations to use for non-identity dictionaries.
	The keys are all #= and #== different and are returned out of their
	natural sort order."
	nonIdentityOrderedAssociations
		ifNil: [
			nonIdentityOrderedAssociations :=
				Array
					with: 'testKey' -> 'testValue'
					with: 'testKey3' -> 'testValue3'
					with: 'testKey2' -> 'testValue2'
					with: 'testKey4' -> 'testValue4'].
	"return copies of the associations so they can be safely modified
	in one test without affecting another, but do not copy the keys
	and values"
	^ nonIdentityOrderedAssociations collect: [:each | each copy].! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 10/1/2016 01:31'!
orderedAssociations
	self isTestingIdentityDictionary
		ifTrue: [^ self identityOrderedAssociations]
		ifFalse: [^ self nonIdentityOrderedAssociations]! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 9/30/2016 22:34'!
orderedAssociationsAllButFirst: anInteger
	^ self orderedAssociations allButFirst: anInteger! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 9/30/2016 16:28'!
orderedAssociationsFirst: anInteger
	"GS does not have #first:"
	^ self orderedAssociations
		copyFrom: 1
		to: anInteger! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 9/29/2016 14:17'!
orderedKeys
	^ self orderedAssociations collect: [:each | each key]! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 9/30/2016 16:28'!
orderedKeysFirst: anInteger
	"GS does not have #first:"
	^ self orderedKeys
		copyFrom: 1
		to: anInteger! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 9/29/2016 14:18'!
orderedValues
	^ self orderedAssociations collect: [:each | each value]! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 9/30/2016 16:28'!
orderedValuesFirst: anInteger
	"GS does not have #first:"
	^ self orderedValues
		copyFrom: 1
		to: anInteger! !

!StandardOrderedDictionaryTest methodsFor: 'accessing' stamp: 'monty 12/21/2015 21:31'!
otherOrderPreservingDictionaryClasses
	^ StandardOrderedDictionary withAllSubclasses copyWithout: self dictionaryClass! !

!StandardOrderedDictionaryTest methodsFor: 'assertions' stamp: 'monty 9/30/2016 03:06'!
should: aBlock enumerate: aCollection
	| enumerated |

	enumerated := OrderedCollection new.
	aBlock value: [:each | enumerated add: each].
	self assert: enumerated = aCollection asOrderedCollection.! !

!StandardOrderedDictionaryTest methodsFor: 'assertions' stamp: 'monty 9/30/2016 03:18'!
should: aBlock enumerate: aFirstCollection and: aSecondCollection
	| firstEnumerated secondEnumerated |

	firstEnumerated := OrderedCollection new.
	secondEnumerated := OrderedCollection new.
	aBlock value: [:first :second |
		firstEnumerated addLast: first.
		secondEnumerated addLast: second].
	self
		assert: firstEnumerated = aFirstCollection asOrderedCollection;
		assert: secondEnumerated = aSecondCollection asOrderedCollection.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:29'!
testAdd
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations withIndexDo: [:each :i |
		self
			deny: (dictionary includesAssociation: each);
			assert: (dictionary add: each) == each;
			assert: (dictionary includesAssociation: each).
		self
			assertIsDictionary: dictionary
			withOrderedAssociations: (self orderedAssociationsFirst: i)].

	"ensure adding the same associations doesn't change the order"
	self orderedAssociations reverseDo: [:each |
		self assert: (dictionary add: each) == each.
		self
			assertIsDictionary: dictionary
			withOrderedAssociations: self orderedAssociations].

	self changedOrderedAssociations withIndexDo: [:each :i | | old |
		old := self orderedAssociations at: i.
		self
			assert: (dictionary add: each) == each;
			assert: (dictionary includesAssociation: each);
			deny: (dictionary includesAssociation: old).
		self
			assertIsDictionary: dictionary
			withOrderedAssociations:
				(self changedOrderedAssociationsFirst: i),
				(self orderedAssociationsAllButFirst: i)].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:29'!
testAddAll
	| dictionary addedAssociations |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self deny: (dictionary includesAssociation: each)].

	addedAssociations := self orderedAssociations.
	self assert: (dictionary addAll: addedAssociations) == addedAssociations.
	self
		assertIsDictionary: dictionary
		withOrderedAssociations: self orderedAssociations.

	"ensure adding the same associations doesn't change the order"
	addedAssociations := self orderedAssociations reversed.
	self assert: (dictionary addAll: addedAssociations) == addedAssociations.
	self
		assertIsDictionary: dictionary
		withOrderedAssociations: self orderedAssociations.

	addedAssociations := self changedOrderedAssociations.
	self assert: (dictionary addAll: addedAssociations) == addedAssociations.
	self
		assertIsDictionary: dictionary
		withOrderedAssociations: self changedOrderedAssociations.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/29/2016 17:19'!
testAssociationAt
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self
			should: [dictionary associationAt: each key]
			raise: Error.

		dictionary add: each.
		self assert: (dictionary associationAt: each key) = each].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/29/2016 17:19'!
testAssociationAtIfAbsent
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self assert:
			(dictionary
				associationAt: each key
				ifAbsent: [self absentValue]) = self absentValue.

		dictionary add: each.
		self assert:
			(dictionary
				associationAt: each key
				ifAbsent: [self fail]) = each].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/29/2016 17:19'!
testAssociationAtIfPresent
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self assert:
			(dictionary
				associationAt: each key
				ifPresent: [self fail]) isNil.

		dictionary add: each.
		self assert:
			(dictionary
				associationAt: each key
				ifPresent: [:assoc | self newValue -> assoc]) = (self newValue -> each).
		"ensure cull: is used"
		self assert:
			(dictionary
				associationAt: each key
				ifPresent: [self newValue]) = self newValue].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 13:15'!
testAssociations
	| dictionary |

	dictionary := self emptyDictionary.
	self
		assertIsArray: dictionary associations
		withElements: #().
	self orderedAssociations withIndexDo: [:each :i |
		dictionary add: each.
		self
			assertIsArray: dictionary associations
			withElements: (self orderedAssociationsFirst: i)].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 03:06'!
testAssociationsDo
	| dictionary |

	dictionary := self emptyDictionary.
	self
		should: [:block | dictionary associationsDo: block]
		enumerate: #().
	self orderedAssociations withIndexDo: [:each :i |
		dictionary add: each.
		self
			should: [:block | dictionary associationsDo: block]
			enumerate: (self orderedAssociationsFirst: i)].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:28'!
testAssociationsSelect
	| dictionary |

	dictionary := self dictionaryWithOrderedAssociations.
	self orderedAssociations do: [:assoc | | selectedAssociations |
		selectedAssociations := self orderedAssociations copyWithout: assoc.
		self
			assertIsDictionary:
				(dictionary associationsSelect: [:each |
					selectedAssociations includes: each])
			copiedFrom: dictionary
			withOrderedAssociations:
				(self orderedAssociations select: [:each |
					selectedAssociations includes: each])].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/29/2016 17:19'!
testAt
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self
			should: [dictionary at: each key]
			raise: Error.

		dictionary add: each.
		self assert: (dictionary at: each key) = each value].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/29/2016 17:19'!
testAtIfAbsent
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self assert:
			(dictionary
				at: each key
				ifAbsent: [self absentValue]) = self absentValue.

		dictionary add: each.
		self assert:
			(dictionary
				at: each key
				ifAbsent: [self fail]) = each value].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/3/2016 18:17'!
testAtIfAbsentPut
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self assert:
			(dictionary
				at: each key
				ifAbsentPut: [each value]) = each value.
		self assert:
			(dictionary
				at: each key
				ifAbsentPut: [self fail]) = each value].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/29/2016 17:20'!
testAtIfPresent
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self assert:
			(dictionary
				at: each key
				ifPresent: [self fail]) isNil.

		dictionary add: each.
		self assert:
			(dictionary
				at: each key
				ifPresent: [:value | self newValue -> value]) =
					(self newValue -> each value).
		"ensure cull: is used"
		self assert:
			(dictionary
				at: each key
				ifPresent: [self newValue]) = self newValue].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/29/2016 17:20'!
testAtIfPresentIfAbsent
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self assert:
			(dictionary
				at: each key
				ifPresent: [self fail]
				ifAbsent: [self absentValue]) = self absentValue.

		dictionary add: each.
		self assert:
			(dictionary
				at: each key
				ifPresent: [:value | self newValue -> value]
				ifAbsent: [self fail]) = (self newValue -> each value).
		"ensure cull: is used"
		self assert:
			(dictionary
				at: each key
				ifPresent: [self newValue]
				ifAbsent: [self fail]) = self newValue].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:29'!
testAtPut
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations withIndexDo: [:each :i |
		self assert:
			(dictionary
				at: each key
				put: each value) = each value.
		self
			assertIsDictionary: dictionary
			withOrderedAssociations: (self orderedAssociationsFirst: i)].

	self changedOrderedAssociations withIndexDo: [:each :i |
		self assert:
			(dictionary
				at: each key
				put: each value) = each value.
		self
			assertIsDictionary: dictionary
			withOrderedAssociations:
				(self changedOrderedAssociationsFirst: i),
				(self orderedAssociationsAllButFirst: i)].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 23:50'!
testCapacity
	"The current Dictionary implementation allocates more than specified.
	The amount allocated may change in the future but it likely won't ever
	be less than specified, so a >= test is used throughout."

	| defaultCapacity dictionary |

	defaultCapacity := self defaultCapacity.
	dictionary := self dictionaryClass new.
	self assert: dictionary capacity >= defaultCapacity.

	dictionary := self dictionaryClass new: (defaultCapacity / 2) asInteger.
	self assert: dictionary capacity >= (defaultCapacity / 2) asInteger.

	dictionary := self dictionaryClass newFrom: self orderedAssociations.
	self assert: dictionary capacity >= self orderedAssociations size.

	self orderedAssociations size to: 0 by: -1 do: [:i |
		self
			shouldnt: [
				dictionary := self dictionaryClass new: i.
				dictionary addAll: self orderedAssociations]
			raise: Error].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:28'!
testCollect
	| dictionary |

	dictionary := self dictionaryWithOrderedAssociations.
	self
		assertIsDictionary:
			(dictionary collect: [:each | each hash])
		copiedFrom: dictionary
		withOrderedAssociations:
			(self orderedAssociations collect: [:each | each key -> each value hash]).! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:28'!
testCopy
	| dictionary copy |

	dictionary := self dictionaryWithOrderedAssociations.
	copy := dictionary copy.
	self
		assertIsDictionary: dictionary
		withOrderedAssociations: self orderedAssociations.
	self
		assertIsDictionary: copy
		copiedFrom: dictionary
		withOrderedAssociations: self orderedAssociations.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:28'!
testCopyEmpty
	| dictionary copy |

	dictionary := self dictionaryWithOrderedAssociations.
	copy := dictionary copyEmpty.
	self
		assertIsDictionary: dictionary
		withOrderedAssociations: self orderedAssociations.
	self
		assertIsDictionary: copy
		copiedFrom: dictionary
		withOrderedAssociations: #().! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:28'!
testDictionary
	| dictionary |

	dictionary := self emptyDictionary.
	self
		assert: dictionary dictionary class == self internalDictionaryClass;
		assert: dictionary dictionary = self emptyInternalDictionary.

	dictionary := self dictionaryWithOrderedAssociations.
	self
		assert: dictionary dictionary class == self internalDictionaryClass;
		assert: dictionary dictionary = self internalDictionaryWithAssociations.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 03:16'!
testDo
	| dictionary |

	dictionary := self emptyDictionary.
	self
		should: [:block | dictionary do: block]
		enumerate: #().
	self orderedAssociations withIndexDo: [:each :i |
		dictionary add: each.
		self
			should: [:block | dictionary do: block]
			enumerate: (self orderedValuesFirst: i)].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/29/2016 17:03'!
testEquals
	| dictionaryOne dictionaryTwo |

	dictionaryOne := self emptyDictionary.
	dictionaryTwo := self emptyDictionary.
	self
		assertDictionary: dictionaryOne
		equals: dictionaryTwo.

	"For equality, order will not matter"
	self orderedAssociations
		with: self orderedAssociations reversed
		do: [:firstAssociation :secondAssociation |
			dictionaryOne add: firstAssociation.
			dictionaryTwo add: secondAssociation.
			self
				assertDictionary: dictionaryOne
				doesNotEqual: self emptyDictionary.
			self
				assertDictionary: dictionaryTwo
				doesNotEqual: self emptyDictionary.
			dictionaryOne size < self orderedAssociations size
				ifTrue: [
					self
						assertDictionary: dictionaryOne
						doesNotEqual: dictionaryTwo]].

	self
		assertDictionary: dictionaryOne
		equals: dictionaryTwo.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:28'!
testEqualsDictionary
	"cannot use assertDictionary:doesNotEqual: for backwards compatibility with
	older Pharo images where Dictionary>>= uses #isDictionary to test the argument
	because these classes also implement isDictionary"
	self
		deny: self emptyDictionary = self emptyInternalDictionary;
		deny: self dictionaryWithOrderedAssociations = self internalDictionaryWithAssociations! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/29/2016 17:03'!
testEqualsOtherOrderPreservingDictionaries
	self otherOrderPreservingDictionaryClasses do: [:otherClass |
		| dictionary otherDictionary |
		dictionary := self dictionaryClass new.
		otherDictionary := otherClass new.
		dictionary isIdentityDictionary = otherDictionary isIdentityDictionary
			ifTrue: [
				self
					assertDictionary: dictionary
					equals: otherDictionary.
				self orderedAssociations do: [:each |
					dictionary add: each.
					self
						assertDictionary: dictionary
						doesNotEqual: otherDictionary.
					otherDictionary add: each copy.
					self
						assertDictionary: dictionary
						equals: otherDictionary]]
			ifFalse: [
				self
					assertDictionary: dictionary
					doesNotEqual: otherDictionary.
				self orderedAssociations do: [:each |
					dictionary add: each.
					otherDictionary add: each copy.
					self
						assertDictionary: dictionary
						doesNotEqual: otherDictionary]]]! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/29/2016 14:17'!
testHash
	| dictionary otherDictionary internalDictionary otherInternalDictionary |

	dictionary := self emptyDictionary.
	otherDictionary := self emptyDictionary.
	internalDictionary := self emptyInternalDictionary.
	otherInternalDictionary := self emptyInternalDictionary.
	self assert: dictionary hash = otherDictionary hash.
	self orderedAssociations do: [:each |
		dictionary add: each.
		internalDictionary add: each copy.
		"if the internal hashes differ after adding to one, the external should too"
		internalDictionary hash = otherInternalDictionary hash
			ifFalse: [self deny: dictionary hash = otherDictionary hash].

		otherDictionary add: each copy.
		otherInternalDictionary add: each copy.
		"should be equal regardless now"
		self assert: dictionary hash = otherDictionary hash].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/29/2016 17:03'!
testHashOtherOrderPreservingDictionaries
	self otherOrderPreservingDictionaryClasses do: [:otherClass |
		| dictionary otherDictionary |
		dictionary := self dictionaryClass new.
		otherDictionary := otherClass new.
		dictionary isIdentityDictionary = otherDictionary isIdentityDictionary
			ifTrue: [
				self assert: dictionary hash = otherDictionary hash.
				self orderedAssociations do: [:each |
					dictionary add: each.
					otherDictionary add: each copy.
					self assert: dictionary hash = otherDictionary hash]]]! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 14:09'!
testIdentityIndexOfKey
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations withIndexDo: [:each :i |
		self assert: (dictionary identityIndexOfKey: each key) = 0.

		dictionary add: each.
		self
			assert: (dictionary identityIndexOfKey: each key) = i;
			assert: (dictionary identityIndexOfKey: each key copy) = 0].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 14:10'!
testIdentityIndexOfKeyIfAbsent
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations withIndexDo: [:each :i |
		self assert:
			(dictionary
				identityIndexOfKey: each key
				ifAbsent: [self absentValue]) = self absentValue.

		dictionary add: each.
		self assert:
			(dictionary
				identityIndexOfKey: each key
				ifAbsent: [self fail]) = i.
		self assert:
			(dictionary
				identityIndexOfKey: each key copy
				ifAbsent: [self absentValue]) = self absentValue].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 14:06'!
testIncludes
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self deny: (dictionary includes: each value).

		dictionary add: each.
		self assert: (dictionary includes: each value)].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 14:06'!
testIncludesAssociation
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self
			deny: (dictionary includesAssociation: each);
			deny: (dictionary includesAssociation: each key -> each value).

		dictionary add: each.
		self
			assert: (dictionary includesAssociation: each);
			assert: (dictionary includesAssociation: each key -> each value)].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 16:18'!
testIncludesIdentity
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self deny: (dictionary includesIdentity: each value).

		dictionary add: each.
		self
			assert: (dictionary includesIdentity: each value);
			deny: (dictionary includesIdentity: each value copy)].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 14:00'!
testIncludesKey
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self deny: (dictionary includesKey: each key).

		dictionary add: each.
		self assert: (dictionary includesKey: each key)].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 16:13'!
testIndexOfKey
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations withIndexDo: [:each :i |
		self assert: (dictionary indexOfKey: each key) = 0.

		dictionary add: each.
		self assert: (dictionary indexOfKey: each key) = i].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 16:14'!
testIndexOfKeyIfAbsent
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations withIndexDo: [:each :i |
		self assert:
			(dictionary
				indexOfKey: each key
				ifAbsent: [self absentValue]) = self absentValue.

		dictionary add: each.
		self assert:
			(dictionary
				indexOfKey: each key
				ifAbsent: [self fail]) = i].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'JAAyer 12/6/2010 12:11'!
testIsDictionary
	self assert: self dictionaryClass new isDictionary! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/30/2015 11:44'!
testIsIdentityDictionary
	self assert: self emptyDictionary isIdentityDictionary = self isTestingIdentityDictionary! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:28'!
testIsOrderPreservingDictionary
	self
		assert: self dictionaryWithOrderedAssociations isOrderPreservingDictionary;
		deny: self internalDictionaryWithAssociations isOrderPreservingDictionary;
		deny: self orderedAssociations isOrderPreservingDictionary! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 16:11'!
testKeyAtIdentityValue
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self
			should: [dictionary keyAtIdentityValue: each value]
			raise: Error.

		dictionary add: each.
		self assert: (dictionary keyAtIdentityValue: each value) = each key.
		self
			should: [dictionary keyAtIdentityValue: each value copy]
			raise: Error].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 00:14'!
testKeyAtIdentityValueIfAbsent
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self assert:
			(dictionary
				keyAtIdentityValue: each value
				ifAbsent: [self absentKey]) = self absentKey.

		dictionary add: each.
		self assert:
			(dictionary
				keyAtIdentityValue: each value
				ifAbsent: [self fail]) = each key.
		self assert:
			(dictionary
				keyAtIdentityValue: each value copy
				ifAbsent: [self absentKey]) = self absentKey].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 22:30'!
testKeyAtIndex
	| dictionary |

	dictionary := self emptyDictionary.
	self
		should: [dictionary keyAtIndex: 0]
		raise: Error.
	self orderedAssociations withIndexDo: [:each :i |
		self
			should: [dictionary keyAtIndex: i]
			raise: Error.

		dictionary add: each.
		self assert: (dictionary keyAtIndex: i) = each key].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 22:29'!
testKeyAtIndexIfAbsent
	| dictionary |

	dictionary := self emptyDictionary.
	self assert:
		(dictionary
			keyAtIndex: 0
			ifAbsent: [self absentKey]) = self absentKey.
	self orderedAssociations withIndexDo: [:each :i |
		self assert:
			(dictionary
				keyAtIndex: i
				ifAbsent: [self absentKey]) = self absentKey.

		dictionary add: each.
		self assert:
			(dictionary
				keyAtIndex: i
				ifAbsent: [self fail]) = each key].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 00:12'!
testKeyAtValue
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self
			should: [dictionary keyAtValue: each value]
			raise: Error.

		dictionary add: each.
		self assert: (dictionary keyAtValue: each value) = each key].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 00:12'!
testKeyAtValueIfAbsent
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self assert:
			(dictionary
				keyAtValue: each value
				ifAbsent: [self absentKey]) = self absentKey.

		dictionary add: each.
		self assert:
			(dictionary
				keyAtValue: each value
				ifAbsent: [self fail]) = each key].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 00:12'!
testKeyForIdentity
	| dictionary |

	dictionary := self emptyDictionary.
	self orderedAssociations do: [:each |
		self assert: (dictionary keyForIdentity: each value) isNil.

		dictionary add: each.
		self
			assert: (dictionary keyForIdentity: each value) = each key;
			assert: (dictionary keyForIdentity: each value copy) isNil].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 13:15'!
testKeys
	| dictionary |

	dictionary := self emptyDictionary.
	self
		assertIsArray: dictionary keys
		withElements: #().
	self orderedAssociations withIndexDo: [:each :i |
		dictionary add: each.
		self
			assertIsArray: dictionary keys
			withElements: (self orderedKeysFirst: i)].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 03:19'!
testKeysAndValuesDo
	| dictionary |

	dictionary := self emptyDictionary.
	self
		should: [:block | dictionary keysAndValuesDo: block]
		enumerate: #()
		and: #().
	self orderedAssociations withIndexDo: [:each :i |
		dictionary add: each.
		self
			should: [:block | dictionary keysAndValuesDo: block]
			enumerate: (self orderedKeysFirst: i)
			and: (self orderedValuesFirst: i)].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:28'!
testKeysAndValuesRemove
	| dictionary |

	dictionary := self dictionaryWithOrderedAssociations.
	self orderedAssociations withIndexDo: [:removedAssociation :i |
		| unremovedAssociations |
		unremovedAssociations :=
			(self orderedAssociationsAllButFirst: i) asOrderedCollection.
		dictionary keysAndValuesRemove: [:key :value |
			(self isTestingIdentityDictionary
				ifTrue: [key == removedAssociation key]
				ifFalse: [key = removedAssociation key])
				ifTrue: [
					self assert: value = removedAssociation value.
					true]
				ifFalse: [| unremovedAssociation |
					unremovedAssociation := unremovedAssociations removeFirst.
					self isTestingIdentityDictionary
						ifTrue: [self assert: key == unremovedAssociation key]
						ifFalse: [self assert: key = unremovedAssociation key].
					self assert: value = unremovedAssociation value.
					false]].
		self assert: unremovedAssociations isEmpty.
		self
			assertKey: removedAssociation key
			wasRemovedfrom: dictionary].
	self assert: dictionary isEmpty.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 03:11'!
testKeysDo
	| dictionary |

	dictionary := self emptyDictionary.
	self
		should: [:block | dictionary keysDo: block]
		enumerate: #().
	self orderedAssociations withIndexDo: [:each :i |
		dictionary add: each.
		self
			should: [:block | dictionary keysDo: block]
			enumerate: (self orderedKeysFirst: i)].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 13:15'!
testKeysSortedSafely
	| dictionary |

	dictionary := self emptyDictionary.
	self
		assertIsArray: dictionary keysSortedSafely
		withElements: #().
	self orderedAssociations withIndexDo: [:each :i |
		dictionary add: each.
		"The keys are all strings, so the default #sorted implementation is OK."
		self
			assertIsArray: dictionary keysSortedSafely
			withElements: (self orderedKeysFirst: i) sorted].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 4/11/2017 01:41'!
testLazyDictionary
	self isTestingLazyDictionary
		ifFalse: [^ self].

	self assert:
		self emptyDictionary orderPreservingDictionary ==
			self dictionaryClass emptyOrderPreservingDictionary.
	self assert:
		self dictionaryClass emptyOrderPreservingDictionary isEmpty.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 16:50'!
testNewFrom
	| dictionary |
	
	dictionary := self dictionaryClass newFrom: self orderedAssociations.
	self
		assertIsDictionary: dictionary
		withOrderedAssociations: self orderedAssociations.
	self
		assertIsDictionary: (self dictionaryClass newFrom: dictionary)
		copiedFrom: dictionary
		withOrderedAssociations: self orderedAssociations.
	self
		assertIsDictionary:
			(self dictionaryClass newFrom: self internalDictionaryWithAssociations)
		withUnorderedAssociations: self orderedAssociations.! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 00:09'!
testNewFromPairs
	| pairs |

	pairs := OrderedCollection new.
	self orderedAssociations do: [:each |
		pairs
			addLast: each key;
			addLast: each value].

	0 to: pairs size do: [:i |
		self
			assertIsDictionary:
				(self dictionaryClass newFromPairs: (pairs copyFrom: 1 to: i))
			withOrderedAssociations:
				(self orderedAssociationsFirst: (i / 2) floor)].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 00:08'!
testOccurancesOf
	| dictionary |

	dictionary := self emptyDictionary.
	self assert: (dictionary occurrencesOf: self newValue) = 0.
	self orderedKeys withIndexDo: [:each :i |
		dictionary
			at: each
			put: self newValue.
		self assert: (dictionary occurrencesOf: self newValue) = i]! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:28'!
testRemoveAll
	| dictionary removedKeys |

	dictionary := self dictionaryWithOrderedAssociations.
	removedKeys := dictionary keys.
	self
		deny: dictionary isEmpty;
		assert: dictionary removeAll == dictionary;
		assert: dictionary isEmpty.
	removedKeys do: [:each |
		self
			assertKey: each
			wasRemovedfrom: dictionary].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:28'!
testRemoveKey
	| dictionary |

	dictionary := self dictionaryWithOrderedAssociations.
	self orderedAssociations withIndexDo: [:each :i |
		self assert: (dictionary removeKey: each key) = each value.
		self
			assertKey: each key
			wasRemovedfrom: dictionary.
		self
			assertIsDictionary: dictionary
			withOrderedAssociations: (self orderedAssociationsAllButFirst: i).

		self
			should: [dictionary removeKey: each key]
			raise: Error]! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:28'!
testRemoveKeyIfAbsent
	| dictionary |

	dictionary := self dictionaryWithOrderedAssociations.
	self orderedAssociations withIndexDo: [:each :i |
		self assert:
			(dictionary
				removeKey: each key
				ifAbsent: [self fail]) = each value.
		self
			assertKey: each key
			wasRemovedfrom: dictionary.
		self
			assertIsDictionary: dictionary
			withOrderedAssociations: (self orderedAssociationsAllButFirst: i).

		self assert:
			(dictionary
				removeKey: each key
				ifAbsent: [self absentValue]) = self absentValue]! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:28'!
testRemoveKeys
	0 to: self orderedAssociations size do: [:i | | dictionary keysToRemove |
		dictionary := self dictionaryWithOrderedAssociations.

		"make it a set to ensure it supports non-Sequenceable collections"
		keysToRemove :=
			(self isTestingIdentityDictionary
				ifTrue: [IdentitySet]
				ifFalse: [Set])
				"avoid #newFrom: for GS portability"
				withAll: (self orderedKeysFirst: i).
		self assert: (dictionary removeKeys: keysToRemove) == dictionary.
		keysToRemove do: [:each |
			self
				assertKey: each
				wasRemovedfrom: dictionary].

		self
			assertIsDictionary: dictionary
			withOrderedAssociations: (self orderedAssociationsAllButFirst: i)]! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 10/1/2016 01:28'!
testSelect
	| dictionary |

	dictionary := self dictionaryWithOrderedAssociations.
	self orderedValues do: [:value | | selectedValues |
		selectedValues := self orderedValues copyWithout: value.
		self
			assertIsDictionary:
				(dictionary select: [:each |
					selectedValues includes: each])
			copiedFrom: dictionary
			withOrderedAssociations:
				(self orderedAssociations select: [:each |
					selectedValues includes: each value])].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 16:54'!
testSize
	| dictionary |

	dictionary := self emptyDictionary.
	self assert: dictionary size = 0.

	self orderedAssociations withIndexDo: [:each :i |
		dictionary add: each.
		self assert: dictionary size = i].

	self orderedAssociations size to: 1 by: -1 do: [:i |
		dictionary removeKey: (self orderedKeys at: i).
		self assert: dictionary size = (i - 1)].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 13:15'!
testValues
	| dictionary |

	dictionary := self emptyDictionary.
	self
		assertIsArray: dictionary values
		withElements: #().
	self orderedAssociations withIndexDo: [:each :i |
		dictionary add: each.
		self
			assertIsArray: dictionary values
			withElements: (self orderedValuesFirst: i)].! !

!StandardOrderedDictionaryTest methodsFor: 'tests' stamp: 'monty 9/30/2016 03:09'!
testValuesDo
	| dictionary |

	dictionary := self emptyDictionary.
	self
		should: [:block | dictionary valuesDo: block]
		enumerate: #().
	self orderedAssociations withIndexDo: [:each :i |
		dictionary add: each.
		self
			should: [:block | dictionary valuesDo: block]
			enumerate: (self orderedValuesFirst: i)].! !

StandardOrderedDictionaryTest subclass: #StandardOrderedIdentityDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-OrderPreservingDictionary'!

StandardOrderedIdentityDictionaryTest subclass: #LazyStandardOrderedIdentityDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-OrderPreservingDictionary'!

!LazyStandardOrderedIdentityDictionaryTest methodsFor: 'accessing' stamp: 'monty 4/10/2017 22:07'!
dictionaryClass
	^ LazyStandardOrderedIdentityDictionary! !

!LazyStandardOrderedIdentityDictionaryTest methodsFor: 'testing' stamp: 'monty 4/11/2017 01:32'!
isTestingLazyDictionary
	^ true! !

!StandardOrderedIdentityDictionaryTest methodsFor: 'accessing' stamp: 'monty 11/20/2014 19:24'!
dictionaryClass
	^ StandardOrderedIdentityDictionary! !

!StandardOrderedIdentityDictionaryTest methodsFor: 'testing' stamp: 'monty 12/15/2014 16:44'!
isTestingIdentityDictionary
	^ true! !
